{Graph320X200 unit
       -Free Pascal
       -DOS, DPMI
}
Unit graph;

Interface

Uses Go32;

Type TScreen320X200 = array[0..199,0..319] of byte;
     TPalEntry      = packed record
                             R,G,B : byte;
                      end;
     TPal           = array[0..255] of TPalEntry;

Var ScreenSeg : word;

Procedure Init320X200;
Procedure CloseGraph;
Procedure Disp320X200(var ScreenBuf : TScreen320X200);
Procedure Fill320X200(var ScreenBuf : TScreen320X200;value : longint);
Procedure SetPal(var pal : TPal);

Implementation

Procedure Init320X200;
begin
      ScreenSeg:=allocate_ldt_descriptors(1);
      set_segment_base_address(ScreenSeg,$0a0000);
      set_segment_limit(ScreenSeg,$FFFF);
      asm
             movw $0x13,%ax
             int $0x10
      end;
end;

Procedure CloseGraph;
begin
      free_ldt_descriptor(ScreenSeg);
      asm
             movw $0x3,%ax
             int $0x10
      end;
end;

Procedure Disp320X200(var ScreenBuf : TScreen320X200); assembler;
asm
             pushw %es
             movl ScreenBuf,%esi
             movw ScreenSeg,%es
             xorl %edi,%edi
             movl $16000,%ecx
             rep
             movsl
             popw %es
end;

Procedure Fill320X200(var ScreenBuf : TScreen320X200;value : longint);assembler;
asm
             movl ScreenBuf,%edi
             movl Value,%eax
             movl $16000,%ecx
             rep
             stosl
end;

Procedure SetPal(var pal : Tpal);assembler;
asm
        movl pal,%esi
        movw $0x03c8,%dx
        xorb %al,%al
        outb %al,%dx
        movl $768,%ecx
        incw %dx
        cld
        rep
        outsb
end;

Begin
End.

